////////////////////////////////////////////////////////////////////////////////
// MAIN.C - Backtracking Maze Generator based on Compute! magazine BASIC prg  //
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "icon.h"

char VersionPtr[] = "Cmaze"; // Program name (Ribbon name)
int AppStackSize = 3000;

void CmazeThread(void)
{
  short a=161, b;                 // Starting spot
  short d[4]={2,-160,-2,160};     // Directions
  char m[4000], c, j, w=35, h=32; // w=wall h=hole
  MESSAGE msg;
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  srand(RimGetTicks());

  for (;;) // Start message loop
  {
    LcdClearDisplay();
    memset(m, h, 4000);
    for(c=1; c<50; c++)
      for(j=0; j<79; j++)
        m[c*80+j]=w;  // Fill with wall blocks
    m[a]=4;           // Define start/done point

    do{
      j=rand() & 3;
      c=j;
l1:
      b=a+d[j];
      if (m[b]==w)
      {
        m[b] = j;
        m[a+d[j]/2] = h;
        a = b;
        continue;
      }
      j = (j+1)*(j<3);
      if(j!=c) goto l1;
      j = m[a];
      m[a] = h;
      a -= d[j];
    }while(j<4);  // Done point check

    for(c=1; c<50; c++)
    {
      for(j=0; j<79; j++)
      {
        a=m[c*80+j];
        LcdDrawBox(a==w?TRUE:FALSE,j*2,c*3,j*2+1,c*3+2);
      }
    }

    RimGetMessage(&msg);
    if(msg.Device==DEVICE_KEYPAD&&msg.Event==KEY_DOWN)
    {
      if(msg.SubMsg==KEY_ESCAPE) // ESC quits
      {
        RibbonShowRibbon();
        RimTerminateThread();
      }
    }
  } // Message loop
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr, &IconBMP, 0, 40, CmazeThread, AppStackSize);
}
